%global momorel 5
Summary: NFS utlilities and supporting daemons for the kernel NFS server.
Name: nfs-utils
Version: 1.0.6
Release: %{momorel}m
URL: http://sourceforge.net/projects/nfs/
# Source0: ftp://nfs.sourceforge.net/pub/nfs/%{name}-%{version}.tar.gz
%NoSource 0 http://jaist.dl.sourceforge.net/sourceforge/nfs/%{name}-%{version}.tar.gz f17e9983457e1cf61c37f0be4493fce6
Source1: ftp://nfs.sourceforge.net/pub/nfs/nfs.doc.tar.gz
%define idmapvers 0.5
Source2: http://www.citi.umich.edu/projects/nfsv4/linux/libnfsidmap/nfsidmap-%{idmapvers}.tar.gz
%define eventvers 0.9
Source3: http://monkey.org/~provos/libevent-%{eventvers}.tar.gz
%define gssapivers 0.1
Source4: http://www.citi.umich.edu/projects/nfsv4/linux/libgssapi/libgssapi-%{gssapivers}.tar.gz
%define rpcsecgss 0.1
Source5: http://www.citi.umich.edu/projects/nfsv4/linux/librpcsecgss/librpcsecgss-%{rpcsecgss}.tar.gz 

Source10: nfs.init
Source11: nfslock.init
Source12: rpcidmapd.init
Source13: rpcgssd.init
Source14: rpcsvcgssd.init

#
# Upstream Patches
#
Patch1: nfs-utils-1-0-6-post1.patch
Patch2: nfs-utils-1-0-6-post2.patch
Patch3: nfs-utils-1-0-6-post3.patch
Patch4: nfs-utils-1-0-6-post4.patch
Patch5: nfs-utils-1-0-6-post5.patch
Patch6: nfs-utils-1-0-6-post6.patch
Patch7: nfs-utils-1-0-6-post7.patch
Patch8: nfs-utils-1-0-6-post8.patch

#
# CITI NFS4 Patches (nfs-utils-1.0.6-23)
#
Patch20: nfs-utils-1.0.6-citi-rpcdebug.patch
Patch21: nfs-utils-1.0.6-citi-svcgssd_memleak_fix.patch
Patch22: nfs-utils-1.0.6-citi-svcgssd_remove_NOGROUPS.patch
Patch23: nfs-utils-1.0.6-citi-idmapd_remove_mapping_related_options.patch
Patch24: nfs-utils-1.0.6-citi-update_idmapd.patch
Patch25: nfs-utils-1.0.6-citi-idmapd_let_libnfsidmap_parse_conf_file.patch
Patch26: nfs-utils-1.0.6-citi-mountd_flavors.patch
Patch27: nfs-utils-1.0.6-citi-gssd_downcall_err_reporting.patch
Patch28: nfs-utils-1.0.6-citi-gssd_restore_euid_on_failure.patch
Patch29: nfs-utils-1.0.6-citi-svcgssd-princ-to-uid.patch
Patch30: nfs-utils-1.0.6-citi-use_libgssapi.patch
Patch31: nfs-utils-1.0.6-citi-use_librpcsecgss.patch

#
# Local Patches
#
Patch50: nfs-utils-1.0.5-statdpath.patch
Patch51: nfs-utils-1.0.6-zerostats.patch
Patch52: nfs-utils-1.0.6-mountd.patch
Patch53: nfs-utils-1.0.6-expwarn.patch
Patch54: nfs-utils-1.0.6-export-permisions.patch
Patch55: nfs-utils-1.0.6-sgi-statd-fixes.patch
Patch56: nfs-utils-1.0.6-fd-sig-cleanup.patch
Patch57: nfs-utils-1.0.6-idmap-syslog.patch
Patch58: nfs-utils-1.0.6-idmap.conf.patch
Patch59: nfs-utils-1.0.6-rquotad-overflow.patch
Patch60: nfs-utils-1.0.6-statd-notify-hostname.patch
Patch61: nfs-utils-1.0.6-idmap-event.patch

Patch100: nfs-utils-1.0.6-compile.patch
Patch150: nfs-utils-1.0.6-pie.patch

Group: System Environment/Daemons
Obsoletes: nfs-server
Obsoletes: knfsd
Obsoletes: knfsd-clients
Obsoletes: nfs-server-clients 
Obsoletes: knfsd-lock
Provides: nfs-server 
Provides: nfs-server-clients 
Provides: knfsd-lock 
Provides: knfsd-clients 
Provides: knfsd
License: GPL
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: kernel >= 2.2.14, portmap >= 4.0, sed, gawk, sh-utils, fileutils, textutils, grep
Requires: module-init-tools >= 3.0
BuildRequires: krb5-devel >= 1.3.1 autoconf >= 2.57

%description
The nfs-utils package provides a daemon for the kernel NFS server and
related tools, which provides a much higher level of performance than the
traditional Linux NFS server used by most users.

This package also contains the showmount program.  Showmount queries the
mount daemon on a remote host for information about the NFS (Network File
System) server on the remote host.  For example, showmount can display the
clients which are mounted on that host.

%prep
%setup -q -a1 -a2 -a3 -a4 -a5
#
# Set up the support libs
#
mv nfsidmap-%{idmapvers} support/nfsidmap
mv libevent-%{eventvers} support/event
mv libgssapi-%{gssapivers} support/gssapi
mv librpcsecgss-%{rpcsecgss} support/rpcsecgss

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%patch20 -p1
%patch21 -p1
%patch22 -p1 
%patch23 -p1 
%patch24 -p1 
%patch25 -p1 
%patch26 -p1 
%patch27 -p1 
%patch28 -p1 
%patch29 -p1 
%patch30 -p1 
%patch31 -p1 

%patch50 -p1 -b .statdpath
%patch51 -p1 -b .zerostats
%patch52 -p1 -b .mountd
%patch53 -p1 -b .expwarn
%patch54 -p1 -b .expperms
%patch55 -p1 -b .sgi
%patch56 -p1 -b .cleanup
%patch57 -p1 -b .syslog
%patch58 -p1 -b .conf
%patch59 -p1 -b .overflow
%patch60 -p1 -b .notify
%patch61 -p1 -b .event


# Do the magic to get things to compile
%patch100 -p1 -b .compile
%patch150 -p1 -b .pie
%ifarch s390 s390x
perl -pi -e 's/-fpie/-fPIE/' */*/Makefile
%endif

%build

autoconf

#
# Hack to enable netgroups.  If anybody knows the right way to do
# this, please help yourself.
#
ac_cv_func_innetgr=yes \
	CFLAGS="%{optflags}" %configure --enable-secure-statd

cd support/nfsidmap; %configure --prefix=%{buildroot}
cd ../../support/event; %configure --prefix=%{buildroot}
cd ../../support/gssapi; %configure --prefix=%{buildroot}
cd ../../support/rpcsecgss; %configure --prefix=%{buildroot}
cd ../../

make all

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}{/sbin,/usr/sbin}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/{man5,man8}
mkdir -p %{buildroot}%{_initscriptdir}
make install install_prefix=%{buildroot}
install -s -m 755 tools/rpcdebug/rpcdebug %{buildroot}/sbin
install -m 755 %{SOURCE10} %{buildroot}%{_initscriptdir}/nfs
install -m 755 %{SOURCE11} %{buildroot}%{_initscriptdir}/nfslock
install -m 755 %{SOURCE12} %{buildroot}%{_initscriptdir}/rpcidmapd
install -m 755 %{SOURCE13} %{buildroot}%{_initscriptdir}/rpcgssd
install -m 755 %{SOURCE14} %{buildroot}%{_initscriptdir}/rpcsvcgssd

install -m 644 utils/idmapd/idmapd.conf \
	%{buildroot}/etc/idmapd.conf
install -m 644 support/gssapi/SAMPLE_gssapi_mech.conf \
	%{buildroot}/etc/gssapi_mech.conf

mkdir -p %{buildroot}/var/lib/nfs/rpc_pipefs

touch %{buildroot}/var/lib/nfs/rmtab
mv %{buildroot}/usr/sbin/{rpc.lockd,rpc.statd} %{buildroot}/sbin

mkdir -p %{buildroot}/var/lib/nfs/statd

# we are using quotad from quota utils
rm %{buildroot}/%{_mandir}/man8/rquotad*
rm %{buildroot}/%{_mandir}/man8/rpc.rquotad*
rm %{buildroot}/%{_sbindir}/rpc.rquotad

%clean
rm -rf %{buildroot}

%pre
/usr/sbin/useradd -c "RPC Service User" -r \
        -s /sbin/nologin -u 29 -d /var/lib/nfs rpcuser 2>/dev/null || :
# Define the correct unsigned uid value for 32 or 64 bit archs
%ifarch %{all_32bit_archs}
%define nfsnobody_uid   65534
%else
%define nfsnobody_uid   4294967294
%endif

# If UID 65534 (or 4294967294 64bit archs) is unassigned, create user "nfsnobody"
cat /etc/passwd | cut -d':' -f 3 | grep --quiet %{nfsnobody_uid} 2>/dev/null
if [ "$?" -eq 1 ]; then
	/usr/sbin/useradd -c "Anonymous NFS User" -r \
		-s /sbin/nologin -u %{nfsnobody_uid} -d /var/lib/nfs nfsnobody 2>/dev/null || :
fi

%post
/sbin/chkconfig --add nfs
/sbin/chkconfig --add nfslock
/sbin/chkconfig --add rpcidmapd
/sbin/chkconfig --add rpcgssd
/sbin/chkconfig --add rpcsvcgssd
if ! [ grep sunrpc /etc/modprobe.conf >& /dev/null ] ; then
  cat << EOF >> /etc/modprobe.conf
install sunrpc /sbin/modprobe --ignore-install sunrpc && /bin/mount -t rpc_pipefs sunrpc /var/lib/nfs/rpc_pipefs
EOF
fi

%preun
if [ "$1" = "0" ]; then
    %{_initscriptdir}/nfs stop
	%{_initscriptdir}/rpcgssd stop
	%{_initscriptdir}/rpcidmapd stop
    %{_initscriptdir}/nfslock stop
    /sbin/chkconfig --del rpcidmapd
    /sbin/chkconfig --del rpcgssd
    /sbin/chkconfig --del rpcsvcgssd
    /sbin/chkconfig --del nfs
    /sbin/chkconfig --del nfslock
    /usr/sbin/userdel rpcuser 2>/dev/null || :
    /usr/sbin/groupdel rpcuser 2>/dev/null || :
    /usr/sbin/userdel nfsnobody 2>/dev/null || :
fi

%postun
if [ "$1" -ge 1 ]; then
	%{_initscriptdir}/rpcidmapd condrestart > /dev/null
	%{_initscriptdir}/rpcgssd condrestart > /dev/null
	%{_initscriptdir}/nfs condrestart > /dev/null
fi

%triggerpostun -- nfs-server
/sbin/chkconfig --add nfs

%triggerpostun -- knfsd
/sbin/chkconfig --add nfs

%triggerpostun -- knfsd-clients
/sbin/chkconfig --add nfslock

%files
%defattr(-,root,root)
%config %{_initscriptdir}/nfs
%config %{_initscriptdir}/rpcidmapd
%config %{_initscriptdir}/rpcgssd
%config %{_initscriptdir}/rpcsvcgssd
%config(noreplace) /etc/idmapd.conf
%config(noreplace) /etc/gssapi_mech.conf
%dir /var/lib/nfs/rpc_pipefs
%dir /var/lib/nfs
%dir %attr(700,rpcuser,rpcuser) /var/lib/nfs/statd
%config(noreplace) /var/lib/nfs/xtab
%config(noreplace) /var/lib/nfs/etab
%config(noreplace) /var/lib/nfs/rmtab
%config(noreplace) /var/lib/nfs/state
%doc nfs/*.html nfs/*.ps linux-nfs/*
/sbin/rpcdebug
/sbin/rpc.lockd
/sbin/rpc.statd
/usr/sbin/exportfs
/usr/sbin/nfsstat
/usr/sbin/nhfs*
/usr/sbin/rpc.mountd
/usr/sbin/rpc.nfsd
/usr/sbin/showmount
/usr/sbin/rpc.idmapd
/usr/sbin/rpc.gssd
/usr/sbin/rpc.svcgssd
%{_mandir}/*/*
%config %{_initscriptdir}/nfslock

%changelog
* Sun Apr 17 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.6-5m)
- stop rpcidmapd rpcgssd nfslock

* Sat Apr  9 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.6-4m)
- ummm, who's gonna mount /var/lib/nfs/rpc_pipefs?

* Wed Mar  9 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.6-3m)
- sync with FC3(1.0.6-52).
- nfs-utils-1.0.6-statddos_quotabuf.patch and
  nfs-utils-1.0.6-auth_reload.patch is applied as another name.

* Wed Dec  8 2004 TAKAHASHI Tamotsu <tamo>
- (1.0.6-2m)
- apply some of UBUNTU patches
 - Patch0: nfs-utils-1.0.6-statddos_quotabuf.patch
  (CAN-2004-1014: ignore SIGPIPE to fix a DoS vulnerability)
  (CAN-2004-0946: do not use memcpy to fix a buffer overflow on 64 bit platforms)
 - Patch1: nfs-utils-1.0.6-auth_reload.patch
  (call auth_reload more often)

* Sun Aug 29 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (1.0.6-1m)
- updated to 1.0.6

* Wed Jul 21 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.3-5m)
- add uid/gid

* Wed Mar 31 2004 Toru Hoshina <t@momonga-linux.org>
- (1.0.3-4m)
- revised spec. rpc.rquotad belongs quota package.

* Thu Mar 25 2004 Toru Hoshina <t@momonga-linux.org>
- (1.0.3-3m)
- revised spec for rpm 4.2.

* Wed Jul 16 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.0.3-2m)
- add nfsstat-overflow.patch

* Tue Jun  3 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.0.3-1m)
  update to 1.0.3

* Wed Oct 24 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.3.3-8k)
- modify rpc.statd location to /sbin on init script

* Fri Oct 19 2001 Toru Hoshina <t@kondara.org>
- (0.3.3-6k)
- require quota 3.0.1
- move rpc.statd to /sbin.

* Fri Oct 12 2001 Toru Hoshina <t@kondara.org>
- (0.3.3-4k)
- revised nfslock.init to use /usr/sbin/rpc.statd instead of /sbin...

* Sat Sep 29 2001 Toru Hoshina <t@kondara.org>
- (0.3.3-2k)
- nfs.statd...

* Fri Apr 13 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.3.1-2k)
- backport from Jirai

* Fri Apr 13 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (0.3.1-3k)
- upgrade to 0.3.1
- change source URL and URL: tag.
- remove rpc.statd, rpc.lockd (kernels >= 2.2.18+ have automatic NFS lock)
- enable NFSv3

* Thu Mar 15 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.2.1-9k)
- rebuild against glibc-2.2.2 and add nfs-utils.glibc222.time.patch

* Sat Feb  3 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.2.1-7k)
- rebuild againt rpm-3.0.5-39k

* Tue Nov 28 2000 Toru Hoshina <toru@df-usa.com>
- use _initscriptdir macro to keep backword compatibility.

* Sun Nov 19 2000 AYUHANA Tomonori <l@kondara.org>
- (0.2.1-1k)
- upgrade 0.1.9.1-3k to 0.2.1-1k
- remove Distribution
- obey FHS

* Wed Jul 19 2000 AYUHANA Tomonori <l@kondara.org>
- (0.1.9.1-1k)
- ported from RedHat-6.2 Updates
- Be a NoSrc :-P
- rebuild against glibc-2.1.91, X-4.0, rpm-3.0.5
- SPEC fixed ( Distribution, BuildRoot, URL, Source )
- use %configure
- add SBINDIR and MAN*DIR at make install

* Mon Jul 17 2000 Matt Wilson <msw@redhat.com>
- 0.1.9.1
- remove patch0, has been integrated upstream

* Wed Feb  9 2000 Bill Nottingham <notting@redhat.com>
- the wonderful thing about triggers, is triggers are wonderful things...

* Thu Feb 03 2000 Cristian Gafton <gafton@redhat.com>
- switch to nfs-utils as the base tree
- fix the statfs patch for the new code base
- single package that obsoletes everything we had before (if I am to keep
  some traces of my sanity with me...)

* Mon Jan 17 2000 Preston Brown <pbrown@redhat.com>
- use statfs syscall instead of stat to determinal optimal blksize
